;--------------------------------------------------------------------
; SUDO14.ASM
; version 1.1
; november 2004
; stephaneDOTgeleyATfreeDOTfr
; modifie en 2014 par Andrec
;--------------------------------------------------------------------

ROM_INTERPR	equ	$C4BD
ROM_GET		equ	$c5e8
ROM_PTR_STR	equ	$CCB0
ROM_CLS		equ	$ccce
ROM_LORES0	equ	$d9ed
ROM_SEI		equ	$e76a
ROM_CLI		equ	$e93d
ROM_KEY		equ	$eb78
ROM_TEXT		equ	$ec21
ROM_HIRES		equ	$ec33
ROM_NMI		equ	$f8b2
ROM_PING		equ	$fa9f
ROM_SHOOT		equ	$fab5
ROM_ZAP		equ	$fae1
ROM_EXPLODE	equ	$facb
ROM_CLICK1	equ	$fb14
ROM_CLICK2	equ	$fb2a

RAM_LORES		equ	$bb80
RAM_CHARSET	equ	$b400
KBD_CODE		equ	$0208
KBD_CTLCODE	equ	$0209
RAM_STATUS	equ	$026a
RAM_PAPER		equ	$026b
RAM_INK		equ	$026c
RAM_CLOCK		equ	$0276

RAM_READY		equ	$1B
RAM_TIB		equ	$35
RAM_ZEROPAGE	equ	$60
RAM_START	equ	$1000
RAM_HEAP	equ	$2000
RAM_GRID	equ	$3000

HEAP_PAGE_ZERO	equ	RAM_HEAP + $0000
HEAP_STATE	equ	RAM_HEAP + $0100
HEAP_NUMBER	equ	RAM_HEAP + $0200
HEAP_CHARSET	equ	RAM_HEAP + $0300

KEY_RIGHT	equ	$08
KEY_LEFT	equ	$09
KEY_DOWN	equ	$0a
KEY_UP		equ	$0b
KEY_ESCAPE	equ	$1b
KEY_SPACE	equ	$20
KEY_1		equ	$31
KEY_2		equ	$32
KEY_3		equ	$33
KEY_4		equ	$34
KEY_5		equ	$35
KEY_6		equ	$36
KEY_7		equ	$37
KEY_8		equ	$38
KEY_9		equ	$39
KEY_SHIFT_1	equ	$A8
KEY_SHIFT_2	equ	$B2
KEY_SHIFT_3	equ	$B8
KEY_SHIFT_4	equ	$9A
KEY_SHIFT_5	equ	$90
KEY_SHIFT_6	equ	$8A
KEY_SHIFT_7	equ	$80
KEY_SHIFT_8	equ	$87
KEY_SHIFT_9	equ	$8B
KEY_C		equ	$43
KEY_E		equ	$45
KEY_F		equ	$46
KEY_H		equ	$48
KEY_L		equ	$4C
KEY_N		equ	$4E
KEY_P		equ	$50
KEY_Q		equ	$51
KEY_R		equ	$52
KEY_S		equ	$53
KEY_U		equ	$55
KEY_V		equ	$56

DEFAUT_PAPER	equ	$17		; #$17 couleur du fond d'cran = blanc
DEFAUT_INK	equ	$02		; #$02 couleur d'encre par dfaut = vert

GRID_X		equ	8
GRID_Y		equ	5
BLOC_LARGEUR	equ	14		; largeur du bloc de 5x5 chiffres = 14
BLOC_HAUTEUR equ	11		; hauteur du bloc de 5x5 chiffres = 11
GRID_MIN		equ	0
GRID_MAX		equ	8

GRID_COLOR1	equ	$04
GRID_COLOR2	equ	$06
GRID_COLOR3	equ	$01
BLOC_COULEUR	equ	$13		; #$13 couleur du bloc de 5x5 chiffres = jaune

LEVEL_MIN		equ	0
LEVEL_MAX		equ	19
LEVEL_SIZE	equ	81

STATE_DISABLED	equ	0
STATE_NORMAL	equ	1
STATE_DRAFT	equ	2

MODE_CONTINUE	equ	0
MODE_RELOAD	equ	1
MODE_EXIT		equ	2

;--------------------------------------------------------------------

		org	RAM_ZEROPAGE

;--------------------------------------------------------------------

; global variables  partir de $60
_grid		equ	$60
_screen		equ	$62
_x			equ	$64
_y			equ	$65
_state		equ	$66
_number		equ	$67
_choice		equ	$68
_key			equ	$72
_level		equ	$73
_mode		equ	$74
_holes		equ	$75
_kbdcode		equ	$76

;--------------------------------------------------------------------

; void Plot(x,y,state,number)

plot_x		equ	$77
plot_y		equ	$78

; void checkGrid()

checkgrid_x	equ	$79
checkgrid_y	equ	$7A
checkgrid_tmp	equ	$7B

; {_state,_number} getGrid(getgrid_x,getgrid_y,_state,_number)

getgrid_x		equ	$7C
getgrid_y		equ	$7D

; void setGrid(setgrid_x,setgrid_y,_state,_number)

setgrid_x		equ	$7E
setgrid_y		equ	$7F

; void loadGrid(_level) Met en place les 81 chiffres de la grille _level

loadgrid_state		equ	$80

;--------------------------------------------------------------------

		org     RAM_START

;--------------------------------------------------------------------

Start	jmp	loadData	; charge SUDSETxx.COM dans le tableau RAM_GRID

Start1	jsr	Startup	; met en place paramtres
		jsr	Main		; jeu proprement dit
		jsr	Shutdown	; c'est fini, on ferme !

		rts

;--------------------------------------------------------------------

Startup	jsr	ROM_TEXT		; Cde TEXT
		jsr	ROM_LORES0	; Cde LORES0

		lda	#$0a
		sta	RAM_STATUS	; curseur off, bruit clavier on

		lda	#$00
		sta	RAM_LORES + 35	; efface CAPS

		lda	#DEFAUT_PAPER
		sta	RAM_PAPER		; papier blanc
		
		lda	#DEFAUT_INK
		sta	RAM_INK		; encre verte

		jsr	ROM_CLS		; Cde CLS

		ldx	#RAM_ZEROPAGE		; pour sauver la page zro
startup1	lda	$00,x			; de $60  $FF
		sta	HEAP_PAGE_ZERO,x	; dans tableau HEAP_PAGE_ZERO en $2000
		inx
		bne	startup1

		ldx	#$00				; pour sauver les caractres de 'a'  'i'
startup2	lda	RAM_CHARSET + ('a' * 8),x
		sta	HEAP_CHARSET,x
		lda	_charset_draft,x	; et les remplacer par les chiffres 'drafts'
		sta	RAM_CHARSET + ('a' * 8),x
		inx
		cpx	#9 * 8			; 9 caractres, 8 octets par caractre
		bne	startup2

		ldx	#$00				; pour copier les 5 adresses (coin haut gauche)
startup3	lda	_grid_block,x		; des sous-grilles 3x3 dont le fond sera jaune
		sta	_screen
		lda	_grid_block + 1,x	; 2 octets par adresse
		sta	_screen + 1
		jsr	drawBlock			; met le fond de la sous-grille en jaune
		inx
		inx					; 2 octets par adresse
		cpx	#5 * 2			; et 5 adresses
		bne	startup3

		rts

;--------------------------------------------------------------------

; void Shutdown()

Shutdown	jsr	ROM_TEXT			; Cde REXT
		jsr	ROM_LORES0		; Cde LORES0

		lda	#%00000111
		sta	RAM_LORES + 35		; affiche CAPS

		lda	#$03
		sta	RAM_STATUS		; curseur on

		lda	#%00010111
		sta	RAM_PAPER			; papier blanc
		
		lda	#%00000000
		sta	RAM_INK			; encre noire

		jsr	ROM_CLS			; Cde CLS

		ldx	#$00				; pour restaurer les caractres de 'a'  'i'
shutdown1	lda	HEAP_CHARSET,x
		sta	RAM_CHARSET + ('a' * 8),x
		inx
		cpx	#9 * 8
		bne	shutdown1

		ldx	#RAM_ZEROPAGE		; pour restaurer la page zro de $60  $FF
shutdown2	lda	HEAP_PAGE_ZERO,x
		sta	$00,x
		inx
		bne	shutdown2

		rts

;--------------------------------------------------------------------

; Main est la partie principale, qui gre le jeu proproment dit

Main		lda	#$00
		sta	_level		; met  zro le numro de grille
		sta	_x
		sta	_y			;  met  zro les coordonnes du curseur

main_reload	lda	#MODE_CONTINUE
		sta	_mode		; reinitialise en mode continue

		jsr	loadGrid		; cherche dans les data originaux les 81 chiffres
						; de la grille _level et initialise les tableaux
						; HEAP_STATE et HEAP_NUMBER

main_drawLevel	jsr	drawLevel	; affiche le n de grille en haut de l'cran

main_continue	jsr	checkGrid	; labore le tableau _choice pour la case _x _y
		jsr	drawGrid		; affiche les 81 chiffres et tats, compte les
						; cases vides, affiche les hypothses possibles

		lda	_holes
		bne	main_key		; s'il reste des cases vides, saute  main_key
		jsr	ROM_PING		; Cde PING s'il n'y a plus de case vide
main_key	jsr	Key			; analyse les touches presses

		lda	_mode
		cmp	#MODE_CONTINUE
		beq	main_continue	; si le mode est 'continue'

		cmp	#MODE_RELOAD
		beq	main_reload	; si le mode est 'reload'

		rts				; reste donc seulement MODE_EXIT

;--------------------------------------------------------------------

; Key est le coeur du jeu. Ce sous-programme analyse les touches presses
; et lance la procdure correspondante

Key		jsr	ROM_KEY			; touche ?
		bpl	Key				; non, reboucle
		sta	_key				; oui sauve le code Ascii au cas o pas shift
		lda	KBD_CODE			; $0208 scan-code touches ordinaires
		sta _kbdcode			; sauve scan-code pour key_shift1
		lda	KBD_CTLCODE		; $0209 scan-code touches de fonction: 
		cmp	#$A4				; rien=38 ctrl=A2 funct=A3 ShiftG=A4 ShiftD=A7
		bmi	key_noshift		; X-A4 est positif si shift G ou D
		jmp	key_shift1		; shift a t press

key_noshift	lda	_key			; rcupre le code Ascii de la touche

		cmp	#KEY_UP			; KEY_UP flche vers le haut
		bne	key_down			; non, commande suivante
		lda	_y
		cmp	#GRID_MIN
		beq	key_up1			; rts si curseur dj au bord du haut
		dec	_y				; sinon indexe la case au dessus
key_up1		rts

key_down	cmp	#KEY_DOWN			; KEY_DOWN flche vers le bas
		bne	key_right			; non, commande suivante
		lda	_y
		cmp	#GRID_MAX
		beq	key_down1			; rts si curseur dj au bord du bas
		inc	_y				; sinon indexe la case au dessous
key_down1	rts

key_right	cmp	#KEY_RIGHT		; KEY_RIGHT flche vers la droite
		bne	key_left			; non, commande suivante
		lda	_x
		cmp	#GRID_MIN
		beq	key_right1		; rts si curseur dj au bord de droite
		dec	_x				; sinon indexe la case de droite
key_right1	rts

key_left	cmp	#KEY_LEFT			; KEY_LEFT flche vers la gauche
		bne	key_c			; non, commande suivante
		lda	_x
		cmp	#GRID_MAX
		beq	key_left1			; rts si curseur dj au bord de gauche
		inc	_x				; sinon indexe la case de gauche
key_left1	rts
						; fin de l'analyse des touches flches
						; il reste C, E, L, H, V, U, F, R, Q, N, S, P, 
						; ESP, ESC, chiffres de 1  9 avec ou sans Shift			
key_c	cmp	#KEY_C			; KEY_C Convertit les hypothses en normaux
		bne	key_e			; non, commande suivante
		jmp	convert			; oui, change les drafts en normaux

key_e	cmp	#KEY_E			; KEY_E Efface les chiffres drafts
		bne	key_l			; non, commande suivante
		jmp	erase			; oui, efface les chiffres drafts

key_l	cmp	#KEY_L			; KEY_L reLoad the previously saved grid
		bne	key_h			; non, commande suivante
		jmp	loadJeu			; oui, suite en loadJeu

key_h	cmp	#KEY_H			; KEY_H recHarge la grille sauve et le contexte
		bne	key_v			; non, commande suivante
		jmp	loadJeu			; oui, suite en loadJeu

key_v	cmp	#KEY_V			; KEY_V sauVe la grille en cours et le contexte
		bne	key_u			; non, commande suivante
		jmp	saveJeu			; oui, suite en saveJeu

key_u	cmp	#KEY_U			; KEY_U recall controls (version UK) 
		bne	key_f			; non, commande suivante
		jmp	saveSwap			; oui, sauve la grille en cours, puis charge
							; l'cran d'aide UK et enfin revient  la grille
		
key_f	cmp	#KEY_F			; KEY_F aide pour les touches (version FR)
		bne	key_r			; non, commande suivante
		jmp	saveSwap			; oui, sauve la grille en cours, puis charge
							; l'cran d'aide FR et enfin revient  la grille

key_r	cmp	#KEY_R			; KEY_R Recharge mme grille (chiffres originaux)
		bne	key_q			; non, commande suivante
		lda	#MODE_RELOAD		; _mode = MODE_RELOAD
		sta	_mode
		rts

key_q	cmp	#KEY_Q			; KEY_Q Quitte Sudoku
		bne	key_p			; non, commande suivante
		lda	#MODE_EXIT		; _mode = MODE_EXIT
		sta	_mode
		rts

key_p	cmp	#KEY_P			; KEY_P charge la grille Prcdente
		bne	key_n			; non, commande suivante
		lda	_level
		cmp	#LEVEL_MIN
		beq	key_p1			; rts si c'est dj la premire grille
		dec	_level			; sinon _level prcdent
		lda	#MODE_RELOAD		; _mode = MODE_RELOAD
		sta	_mode
key_p1	rts

key_n	cmp	#KEY_N			; KEY_N load Next grid
		beq	key_s1			; oui, suite code commun 'N' et 'S'
							; non, examine si 'S'
key_s	cmp	#KEY_S			; KEY_S charge la grille Suivante
		bne	key_space			; non, commande suivante
key_s1	lda	_level			; oui, c'est N ou S
		cmp	#LEVEL_MAX		; dernire grille dj faite ?
		beq	key_s2			; oui, on retourne
		inc	_level			; non, on passe au _level suivant
		lda	#MODE_RELOAD		; _mode = MODE_RELOAD
		sta	_mode			; pour qu'il soit charg
key_s2	rts
						; fin de l'analyse des touches flches et des
						; Cdes C, E, L, H, V, U, F, R, Q, N, S, P. Il reste 
						; ESP, ESC, chiffres de 1  9 avec ou sans Shift
		
key_space	ldx	_x
		ldy	_y
		stx	getgrid_x		; initialise les coordonnes curseur pour getGrid
		sty	getgrid_y
		jsr	getGrid		; revient avec chiffre et tat de la case _x _y
		lda	_key				; avait t modifi par getGrid
		cmp	#KEY_SPACE		; KEY_SPACE pour effacer la case
		bne	key_escape		; non, commande suivante
		lda	_state
		cmp	#STATE_DISABLED
		beq	key_s1			; si case verrouille, simple RTS
		lda	#STATE_NORMAL		; force l'tat de la case  'normal'
		sta	_state			; (au cas o il aurait t 'draft')
		lda	#$00
		sta	_number			; chiffre = zro (case vide)
		clc
		bcc	key_set			; suite force (quivaut  un jmp)

key_escape	cmp	#KEY_ESCAPE	; KEY_ESCAPE pour (d)verrouiller case
		bne	key_1			; non, commande suivante
		lda	_number			; oui, teste le chiffre
		beq	key_escape2		; case vide, rts car n'est pas concerne
		lda	_state			; teste l'tat
		cmp	#STATE_NORMAL		; 'normal' ?
		bne	key_escape1		; non (si dj verrouill ou si draft)
		lda	#STATE_DISABLED	; oui, bascule l'tat normal
		sta	_state			; pour qu'il devienne verrouill
		clc
		bcc	key_set			; suite force (quivaut  un jmp)
key_escape1	cmp	#STATE_DISABLED	; 'draft' ou 'disabled' ?
		bne	key_escape2			; simple rts si 'draft'
		lda	#STATE_NORMAL		; si c'tait 'disabled', on bascule
		sta	_state			; l'tat sur 'normal'
		clc
		bcc	key_set			; suite force (quivaut  un jmp)
key_escape2	rts
					; on a fait l'analyse des touches flches et des
					; Cdes C, E, L, H, V, U, F, R, Q, N, S, P, ESP, ESC. 
					; Il reste chiffres de 1  9 avec ou sans Shift

key_1	cmp	#KEY_1			; examine si touche 1  9
		bcc	key_shift1		; branche si A < #31 (Ascii < chiffre 1)
		cmp	#KEY_9 + 1		; A - 10 fictif, positionne N, Z et C
		bcs	key_shift1		; branche si A >= #39 (Ascii > chiffre 9)
							; = branche si shift ou erreur de touche
		and	#$0f				; convertit #31  #39 en #01  #09
		tax					; index pour tableau _choice
		lda	_state			; teste l'tat de la case
		cmp	#STATE_DISABLED
		beq	key_other			; simple RTS si la case est protge
		lda	_choice,x			; teste si ce chiffre est choix possible
		bne	key_other			; simple RTS si pas choix possible
		stx	_number			; ok chiffre accept
		ldx	_x				; reprend abscisse _x pour setGrid ci-aprs
		lda	#STATE_NORMAL		; force l'tat de la case  'normal' 
		sta	_state			; (ni protg, ni hypothse)
key_set	stx	setgrid_x	 		; initialise les coordonnes curseur
		sty	setgrid_y			; pour mettre  jour la case avec _state
		jmp	setGrid			; et _number, puis retourne dans s/p main

							; reste 'shift + 1  9' ou 'erreur de touche'

key_shift1	ldx	_x
		ldy	_y				; rcupre les coordonnes du curseur
		stx	getgrid_x
		sty	getgrid_y
		jsr	getGrid			; mise  jour de _state et _number
		lda _kbdcode			; rcupre le scan-code 'touche ordinaire'
		ldx	#$00				; l'index X est valide de 0  8
key_shift2	cmp	_shift_key,x	; cherche A dans le tableau des scan-codes
		beq	key_shift3		; trouv, X pointe le chiffre shift
		inx					; pas trouv, indexe suivant
		cpx	#$09				; limite atteinte ?
		bne	key_shift2		; reboucle s'il en reste  comparer
		beq	key_other			; pas trouv, simple RTS (erreur de touche)
key_shift3	inx				; X de 0  8 passe de 1  9
		stx	_number			; c'est le chiffre shift
		lda	_choice,x			; choix possible ?
		bne	key_other			; non, on sort par un RTS
		ldx	_x				; oui, reprend abscisse X
		lda	_state			; reprend tat
		cmp	#STATE_DISABLED	; teste si verrouill
		beq	key_other			; oui, on sort par un RTS
		lda	#STATE_DRAFT		; non, charge drapeau 'draft'
		sta	_state			; et met  jour l'tat
		stx	setgrid_x			; initialise les coordonnes curseur
		sty	setgrid_y			; pour mettre  jour la case avec _state
		jsr	setGrid			; et _number, puis retourne dans s/p main

key_other	rts

;--------------------------------------------------------------------

; void loadData() charge SUDSETxx.COM dans le tableau RAM_GRID

loadData	ldx	#$00
loaddata1	lda	_filename1,x		; Commande Sedoric, terminated by zero
		sta	RAM_TIB,x			; tampon clavier
		beq	loaddata2			; copie termine, zro terminal atteint
		inx					; il en reste  copier
		bne	loaddata1			; reboucle pour copier le caractre suivant

loaddata2	lda	# low loaddata3	; dtourne le vecteur Ready
		sta	RAM_READY			; vers adresse de retour dans ce s/p
		lda	# high loaddata3	; c'est  dire vers loaddata3
		sta	RAM_READY + 1

		ldx	#$34				; pour ajuster le TXTPTR juste avant 
		ldy	#$00				; le dbut de la commande dans le TIB
		jmp	ROM_INTERPR		; donne la main a l'interprteur Atmos

loaddata3	lda	# low ROM_PTR_STR
		sta	RAM_READY			; au retour, restaure l'adresse normale 
		lda	# high ROM_PTR_STR 	; du vecteur "Imprimer chane AY"
		sta	RAM_READY + 1		; utilis poue afficher "Ready"

		pla					; restaure les registres y, x et a
		tay
		pla
		tax
		pla
		jmp	Start1			; retourne au s/p Start

;--------------------------------------------------------------------

; void saveJeu() sauve les tableaux HEAP_STATE et HEAP_NUMBER
; plus le tableau RAM_ZEROPAGE (contexte de jeu)
; dans SUDJEU.COM sur disquette (c'est donc la grille en cours)

saveJeu	ldx #RAM_ZEROPAGE		; #$60 index de dpart
saveJeu0	lda $00,x				; de $60  $ FF
		sta HEAP_STATE,x		; de $2160  $21FF
		inx
		bne saveJeu0			; reboucle tant qu'il en reste

		ldx	#$00
saveJeu1	lda	_filename2,x		; Commande Sedoric, terminated by zero
		sta	RAM_TIB,x			; tampon clavier
		beq	saveJeu2			; copie termine, zro terminal atteint
		inx					; il en reste  copier
		bne	saveJeu1			; reboucle pour copier le caractre suivant

saveJeu2	lda	# low saveJeu3		; dtourne le vecteur Ready
		sta	RAM_READY			; vers adresse de retour dans ce s/p
		lda	# high saveJeu3	; c'est  dire vers saveJeu3
		sta	RAM_READY + 1

		ldx	#$34				; pour ajuster le TXTPTR juste avant 
		ldy	#$00				; le dbut de la commande dans le TIB
		jmp	ROM_INTERPR		; donne la main a l'interprteur Atmos

saveJeu3	lda	# low ROM_PTR_STR
		sta	RAM_READY			; au retour, restaure l'adresse normale 
		lda	# high ROM_PTR_STR 	; du vecteur "Imprimer chane AY"
		sta	RAM_READY + 1		; utilis poue afficher "Ready"

		jmp main_continue

;--------------------------------------------------------------------

; void saveSwap() sauve l'cran-grille dans SWAP.COM,
; puis charge l'cran-aide UK ou FR

saveSwap	ldx	#$00
saveSwap1	lda	_filename6,x		; Commande Sedoric, terminated by zero
		sta	RAM_TIB,x			; tampon clavier
		beq	saveSwap2			; copie termine, zro terminal atteint
		inx					; il en reste  copier
		bne	saveSwap1			; reboucle pour copier le caractre suivant

saveSwap2	lda	# low saveSwap3	; dtourne le vecteur Ready
		sta	RAM_READY			; vers adresse de retour dans ce s/p
		lda	# high saveSwap3	; c'est  dire vers saveSwap3
		sta	RAM_READY + 1

		ldx	#$34				; pour ajuster le TXTPTR juste avant 
		ldy	#$00				; le dbut de la commande dans le TIB
		jmp	ROM_INTERPR		; donne la main a l'interprteur Atmos

saveSwap3	lda	# low ROM_PTR_STR
		sta	RAM_READY			; au retour, restaure l'adresse normale 
		lda	# high ROM_PTR_STR 	; du vecteur "Imprimer chane AY"
		sta	RAM_READY + 1		; utilis poue afficher "Ready"

		lda	_key				; c'tait quoi la touche ?
		cmp	#KEY_U
		beq	saveSwap4			; si 'U', charge aide UK
		cmp	#KEY_F
		beq	saveSwap5			; si 'F', charge aide FR

		jmp main_continue		; ni Aide UK ni aide FR
saveSwap4	jmp loadUk
saveSwap5	jmp loadFr

;--------------------------------------------------------------------

; void loadJeu() charge SUDJEU.COM (grille "en cours" prcdemment
; sauve) dans les tableaux HEAP_STATE, HEAP_NUMBER
; et RAM_ZEROPAGE (contexte de jeu)

loadJeu	ldx	#$00
loadJeu1	lda	_filename3,x		; Commande Sedoric, terminated by zero
		sta	RAM_TIB,x			; tampon clavier
		beq	loadJeu2			; copie termine, zro terminal atteint
		inx					; il en reste  copier
		bne	loadJeu1			; reboucle pour copier le caractre suivant

loadJeu2	lda	# low loadJeu3		; dtourne le vecteur Ready
		sta	RAM_READY			; vers adresse de retour dans ce s/p
		lda	# high loadJeu3	; c'est  dire vers loadJeu3
		sta	RAM_READY + 1

		ldx	#$34				; pour ajuster le TXTPTR juste avant 
		ldy	#$00				; le dbut de la commande dans le TIB
		jmp	ROM_INTERPR		; donne la main a l'interprteur Atmos

loadJeu3	lda	# low ROM_PTR_STR
		sta	RAM_READY			; au retour, restaure l'adresse normale 
		lda	# high ROM_PTR_STR 	; du vecteur "Imprimer chane AY"
		sta	RAM_READY + 1		; utilis poue afficher "Ready"

		ldx #RAM_ZEROPAGE		; #$60 index de dpart
loadJeu4	lda HEAP_STATE,x		; de $2160  $21FF
		sta $00,x				; de $60  $ FF
		inx
		bne loadJeu4			; reboucle tant qu'il en reste

		jmp main_drawLevel

;--------------------------------------------------------------------

; void loadUk() charge SUDOKU02.SCR (cran d'aide en anglais)

loadUk	ldx	#$00
loadUk1	lda	_filename4,x		; Commande Sedoric, terminated by zero
		sta	RAM_TIB,x			; tampon clavier
		beq	loadUk2			; copie termine, zro terminal atteint
		inx					; il en reste  copier
		bne	loadUk1			; reboucle pour copier le caractre suivant

loadUk2	lda	# low loadUk3		; dtourne le vecteur Ready
		sta	RAM_READY			; vers adresse de retour dans ce s/p
		lda	# high loadUk3		; c'est  dire vers loadUk3
		sta	RAM_READY + 1

		ldx	#$34				; pour ajuster le TXTPTR juste avant 
		ldy	#$00				; le dbut de la commande dans le TIB
		jmp	ROM_INTERPR		; donne la main a l'interprteur Atmos

loadUk3	lda	# low ROM_PTR_STR
		sta	RAM_READY			; au retour, restaure l'adresse normale 
		lda	# high ROM_PTR_STR 	; du vecteur "Imprimer chane AY"
		sta	RAM_READY + 1		; utilis poue afficher "Ready"
		jsr	loadCarOrg		; pour que l'cran soit lisible

loadUk4	jsr	ROM_KEY			; touche ?
		bpl	loadUk4			; non, reboucle

		jsr	loadCarRed		; pour que la grille soit lisible
		jmp	loadSwap			; pour restaurer la grille sauve

;--------------------------------------------------------------------

; void loadFr() charge SUDDO03.SCR (cran d'aide en franais)

loadFr	ldx	#$00
loadFr1	lda	_filename5,x		; Commande Sedoric, terminated by zero
		sta	RAM_TIB,x			; tampon clavier
		beq	loadFr2			; copie termine, zro terminal atteint
		inx					; il en reste  copier
		bne	loadFr1			; reboucle pour copier le caractre suivant

loadFr2	lda	# low loadFr3		; dtourne le vecteur Ready
		sta	RAM_READY			; vers adresse de retour dans ce s/p
		lda	# high loadFr3		; c'est  dire vers loadFr3
		sta	RAM_READY + 1

		ldx	#$34				; pour ajuster le TXTPTR juste avant 
		ldy	#$00				; le dbut de la commande dans le TIB
		jmp	ROM_INTERPR		; donne la main a l'interprteur Atmos

loadFr3	lda	# low ROM_PTR_STR
		sta	RAM_READY			; au retour, restaure l'adresse normale 
		lda	# high ROM_PTR_STR 	; du vecteur "Imprimer chane AY"
		sta	RAM_READY + 1		; utilis poue afficher "Ready"
		jsr	loadCarOrg		; pour que l'cran soit lisible

loadFr4	jsr	ROM_KEY			; touche ?
		bpl	loadFr4			; non, reboucle

		jsr	loadCarRed		; pour que la grille soit lisible
		jmp	loadSwap			; pour restaurer la grille sauve

;--------------------------------------------------------------------

; void loadSwap() charge SWAP.COM (la grille avant l'affichage de l'aide)

loadSwap	ldx	#$00
loadSwap1	lda	_filename7,x		; Commande Sedoric, terminated by zero
		sta	RAM_TIB,x			; tampon clavier
		beq	loadSwap2			; copie termine, zro terminal atteint
		inx					; il en reste  copier
		bne	loadSwap1			; reboucle pour copier le caractre suivant

loadSwap2	lda	# low loadSwap3	; dtourne le vecteur Ready
		sta	RAM_READY			; vers adresse de retour dans ce s/p
		lda	# high loadSwap3	; c'est  dire vers loadSwap3
		sta	RAM_READY + 1

		ldx	#$34				; pour ajuster le TXTPTR juste avant 
		ldy	#$00				; le dbut de la commande dans le TIB
		jmp	ROM_INTERPR		; donne la main  l'interprteur Atmos

loadSwap3	lda	# low ROM_PTR_STR
		sta	RAM_READY			; au retour, restaure l'adresse normale 
		lda	# high ROM_PTR_STR 	; du vecteur "Imprimer chane AY"
		sta	RAM_READY + 1		; utilis pour afficher "Ready"

		jmp main_continue

;--------------------------------------------------------------------

; void loadCarOrg() remet les caractres originaux en RAM
; de 'a'  'i'  partir du tableau de sauvegarde HEAP_CHARSET
; Au cours du jeu, on met en RAM soit les car org soit les car redfinis

loadCarOrg	ldx	#$00			; index et compteur
loadCarOrg1	lda	HEAP_CHARSET,x	; zone o sont sauvegards car org
			sta	RAM_CHARSET + ('a' * 8),x	; de $B708  $B74F
			inx				; octet suivant
			cpx	#9 * 8		; 9 car de 8 octets chacun
			bne	loadCarOrg1	; il en reste  copier
			rts				; c'est fini

;--------------------------------------------------------------------

; void loadCarRed() charge en RAM les car redfinis du tableau _charset_draft
; Ce tableau est la zone de sauvegarde permanente des caractres redfinis
; De mme, une copie des car org a t sauve dans HEAP_CHARSET et y reste
; Au cours du jeu, on met en RAM soit les car org soit les car redfinis

loadCarRed	ldx	#$00				; index et compteur
loadCarRed1	lda	_charset_draft,x	; zone o sont les car redfinis
			sta	RAM_CHARSET + ('a' * 8),x	; de $B708  $B74F
			inx					; octet suivant
			cpx	#9 * 8			; 9 car de 8 octets chacun
			bne	loadCarRed1		; il en reste  copier
			rts					; c'est fini

;--------------------------------------------------------------------

; void loadGrid(_level) charge la grille _level dans les tableaux
; HEAP_STATE et HEAP_NUMBER  partir du tableau RAM_GRID en $3000.
; Seuls les chiffres originaux sont donc rechargs.

loadGrid	pha				; sauvegarde les registres a, x et y
		txa
		pha
		tya
		pha

		jsr	findGrid		; findGrid(_level) localise la grille dans les data
						; originaux, revient avec adr grille en $40/$41
	
		ldx	#$00			; index pour les tableaux HEAP_STATE et HEAP_NUMBER
		ldy	#$00			; index pour le tableau RAM_GRID (issu de DATA.TAP)

loadgrid1	lda	#STATE_NORMAL
		sta	loadgrid_state		; par dfaut pour les cases vides

		lda	(_grid),y			; lit une valeur dans le tableau RAM_GRID
		sta	HEAP_NUMBER,x		; et la copie dans le tableau HEAP_NUMBER
		beq	loadgrid2			; si 0, c'est une case vide, garde 'normal'
		lda	#STATE_DISABLED	; si <> 0, c'est un chiffre original donc
		sta	loadgrid_state		; bascule tat en mode 'verrouill'
loadgrid2	lda	loadgrid_state		
		sta	HEAP_STATE,x		; met en place l'tat de ce chiffre

		inx					; index cible chiffre suivant
		iny					; index source chiffre suivant
		cpy	#LEVEL_SIZE		; il y a a 81  copier
		bne	loadgrid1			; reboucle si pas fini

		pla					; restaure les registres y, x et a
		tay
		pla
		tax
		pla
		rts

;--------------------------------------------------------------------

; void findGrid(registres A et Y crass)
; localise une grille dans les data originaux (tableau RAM_GRID)
; en entre, n de la grille dans la variable _level
; en sortie adresse de dbut des 81 chiffres en $40/$41 (_grid)

findGrid	lda	_level		; inutile car immdiatement cras
		lda	# low RAM_GRID
		sta	_grid
		lda	# high RAM_GRID
		sta	_grid + 1		; adresse de dbut du tableau

		ldy	_level
		beq	findgrid3		; dj fini si c'est la grille zro

findgrid1	clc				; pour chaque grille, l'adresse est
		lda	_grid
		adc	#LEVEL_SIZE	; incrmente de 81
		sta	_grid
		bcc	findgrid2
		inc	_grid + 1		; report de la retenue
findgrid2	dey				; dcrmente le nombre de grille
		bne	findgrid1		; reboucle s'il en reste

findgrid3	rts

;--------------------------------------------------------------------

; void checkGrid() Pour une case donne, recherche tous les choix possibles.
; Chacune des 10 cases (corespondant aux chiffres 0  9) est incrmente si le
; chiffre correspondant est trouv dans la ligne, la colonne ou la sous-grille
; A la fin, les choix possibles correspondent aux cases nulles de ce tableau.

checkGrid	lda	#$01
		jsr	checkgrid_set		; remplit les 10 cases de _choice avec  #$01
							; (aucun choix possible par dfaut)
		ldx	_x
		ldy	_y
		stx	getgrid_x			; initialise les coordonnes de la case
		sty	getgrid_y			; au curseur et mise  jour 
		jsr	getGrid			; pour cette case de _state et _number
		lda	_state			; teste l'tat de la case au curseur
		cmp	#STATE_DISABLED	; si la case est vrrouille
		beq	checkgrid99		; simple rts car pas d'hypothse possible
		lda	_state			; reprend l'tat de la case au curseur
		cmp	#STATE_DRAFT		; si la case contient une hypothse, on doit
		beq	checkgrid0		; quand mme en lister les hypothses
		lda	_number			; rts si case au curseur contient un chiffre
		bne	checkgrid99		; ni vrrouille, ni 'draft' donc normal

checkgrid0	lda	#$00			; si la case est vide ou 'draft'
							; il faut donc  lister toutes les hypothses
		jsr	checkgrid_set		; remplit les 10 cases de _choice avec  #$00
							; par dfaut tous les chiffres sont possibles

							; On commence par verifier les 9 cases de la
							; ligne du curseur pour y chercher les
							; chiffres verrouills ou 'normaux'

		ldy	#$00				; c'est pour initialiser getgrid_x !!!
		lda	_y				; ce qui oblige  passer par l'accumulateur A 
		sta	getgrid_y			; pour initialiser l'ordonne de la ligne !!!
checkgrid1	sty	getgrid_x		; le registre Y indexera chacune des 9 cases 
		jsr	getGrid			; lit le chiffre et l'tat de la case indexe
		lda	_state			; si case contient une hypothse on saute les 
		cmp	#STATE_DRAFT		; 3 lignes de code suivantes car on cherche
		beq	checkgrid2		; les chiffres verrouills ou 'normaux'
		lda	_number			; C'est donc un chiffre de 0  9
		tax					; qui sert d'index pour incrmenter la case
		inc	_choice,x			; correspondante du tableau _choice
checkgrid2	iny				; attention c'est pour incrmenter getgrid_x
		cpy	#GRID_MAX + 1		; teste si le bout de la ligne a t atteint
		bne	checkgrid1		; reboucle car il reste des cases  tester

							; On verifie ensuite les 9 cases de la
							; colonne du curseur pour y chercher les
							; chiffres verrouills ou 'normaux'

		ldy	#$00				; cette fois c'est pour indexer getgrid_y
		lda	_x
		sta	getgrid_x			; initialise l'abscisse de la colonne
checkgrid3	sty	getgrid_y		; le registre Y indexera chacune des 9 cases
		jsr	getGrid			;  lit le chiffre et l'tat de la case indexe
		lda	_state			; si case contient une hypothse on saute les
		cmp	#STATE_DRAFT		; 3 lignes de code suivantes car on cherche
		beq	checkgrid4		; les chiffres verrouills ou 'normaux'
		lda	_number			; C'est donc un chiffre de 0  9
		tax					; qui sert d'index pour incrmenter la case
		inc	_choice,x			; correspondante du tableau _choice
checkgrid4	iny				; indexe la case suivante de la colonne
		cpy	#GRID_MAX + 1		; teste si le bas de la colonne a t atteint
		bne	checkgrid3		; reboucle car il reste des cases  tester

							; Enfin on verifie les 9 cases de la sous-
							; grille 3x3 du curseur pour y chercher les
							; chiffres verrouills ou 'normaux'

		ldy	_y				; l'ordonne du curseur est utilise pour
		lda	_grid_xdiv3,y		; lire dans le tableau _grid_xdiv3 l'ordonne
		sta	checkgrid_y		; du coin haut gauche de la sous-gille
		ldy	#$00				; prpare index Y pour utilisation ultrieure

checkgrid5	ldx	_x			; l'abscisse du curseur est utilise pour
		lda	_grid_xdiv3,x		; lire dans le tableau _grid_xdiv3 l'abscisse
		sta	checkgrid_x		; du coin haut gauche de la sous-gille
		ldx	#$00				; prpare index X pour utilisation ultrieure

checkgrid6	lda	checkgrid_x
		sta	getgrid_x			; initialise coordonnes de case pour getGrid
		lda	checkgrid_y
		sta	getgrid_y
		jsr	getGrid			;  lit le chiffre et l'tat de la case indexe
		lda	_state			; si case contient une hypothse on saute les
		cmp	#STATE_DRAFT		; 4 lignes de code suivantes car on cherche
		beq	checkgrid7		; les chiffres verrouills ou 'normaux'
		txa					; C'est donc un chiffre de 0  9
		ldx	_number			; sauve index X dans A et lit le chiffre
		inc	_choice,x			; qui sert d'index pour incrmenter la case
		tax					; rcupre l'index X
checkgrid7	inc	checkgrid_x	; incrmente la case suivante  tester
		inx					; et incrmente aussi l'index X
		cpx	#$03				; limite 3 cases par ligne de la sous-grille
		bne	checkgrid6		; reboucle car il en reste
		inc	checkgrid_y		; sinon, il faut passer  la ligne suivante
		iny					; et du coup incrmenter l'index Y
		cpy	#$03				; limite 3 lignes par sous-grille
		bne	checkgrid5		; reboucle car il en reste

checkgrid99	rts				; retour vers le sous-programme Main

checkgrid_set	ldx	#$00			; routine complmentaire qui rempli
checkgrid_set1	sta	_choice,x		; les 10 cases de _choice avec la
		inx					; valeur prsente dans l'accumulateur A
		cpx	#GRID_MAX + 2		; soit 8 + 2
		bne	checkgrid_set1		; reboucle de 0  9
		rts					; et sort  10

;--------------------------------------------------------------------

; void drawGrid()				; affiche chiffre et tat dans 81 cases
							; compte le nombre de trous (cases vides)
							; affiche la ligne des choix possibles
drawGrid	ldy	#$00				; pour reset du nombre de cases vides
		sty	_holes			; et de l'ordonne de la 1re ligne
drawgrid1	ldx	#$00				; pour reset de l'abscisse de la 1re case
drawgrid2	stx	getgrid_x			; mise  jour des coordonnes de la case
		sty	getgrid_y			;  explorer avec getGrid
		jsr	getGrid			; lit le chiffre et l'tat de la case indexe
		lda	_number		; teste si la case est vide (le chiffre est zro)
		bne	drawgrid3		; bypasse la ligne suivante si ce n'est pas le cas
		inc	_holes		; incrmente le nombre de cases vides
drawgrid3	stx	plot_x		; mise  jour des coordonnes de la case
		sty	plot_y		; pour le sous-programme Plot 
		jsr	Plot			; inscrit le chiffre et son tat dans la case
		inx					; indexe la case suivante
		cpx	#GRID_MAX + 1		; limite de fin de ligne
		bne	drawgrid2			; reboucle s'il reste des cases  remplir
		iny					; indexe la ligne suivante
		cpy	#GRID_MAX + 1		; limite de fin de grille
		bne	drawgrid1			; reboucle s'il reste des lignes  remplir
		ldx	#$00			; abscisse pour ligne des choix possibles
		sty	plot_y		; ordonne pour ligne des choix possibles
		ldy	#$01			; index pour le tableau _choice
drawgrid4	lda	#STATE_NORMAL		; rinitialise l'tat par dfaut  #$01 
		sta	_state			; (tat 'normal') pour crire en bleu

		lda	_choice,y		; teste la case du tableau _choice indexe par Y
		beq	drawgrid5		; si c'est #$00, a correspond  un choix possible
		lda	#STATE_DISABLED
		sta	_state		; force tat  #$00 pour crire en cyan avec Plot

drawgrid5	stx	plot_x		; abscisse pour Plot (ordonne mj plus haut)
		sty	_number		; l'index de _choice est le chiffre  inscrire
		jsr	Plot			; incrit le chiffre _number en bleu ou cyan
						; selon l'tat (cyan = choix possible)
		iny				; incrmente l'index du tableau _choice
		inx				; incrmente l'abcisse dans la barre des choix
		cpx	#GRID_MAX + 1	; limite de fin de barre des choix possibles
		bne	drawgrid4		; reboucle s'il en reste  inscrire

		rts

;--------------------------------------------------------------------

; {_state,_number}getGrid(getgrid_x,getgrid_y,_state,_number)
; Cherche l'tat dans le tableau HEAP_STATE et le chiffre dans le tableau
; HEAP_NUMBER correspndant  la case de coordonnes getgrid_x etgetgrid_y

getGrid	tya
		pha				; sauve y sur la pile

		clc				; pour une addition
		ldy	getgrid_y		; numro de ligne (0  8)
		lda	_grid_y,y		; quivaut  a=y*9 
		adc	getgrid_x		; plus numro de la case
		tay				; donne index d'exploration des tableaux 
						; HEAP_STATE et HEAP_NUMBER
		lda	HEAP_STATE,y	
		sta	_state		; tat de la case getgrid_x et getgrid_y 
		lda	HEAP_NUMBER,y
		sta	_number		; chiffre de la case getgrid_x et getgrid_y

		pla
		tay				; rcupre y
		rts

;--------------------------------------------------------------------

; void setGrid(setgrid_x,setgrid_y,_state,_number)
; Met  jour l'tat dans le tableau HEAP_STATE et le chiffre dans le tableau
; HEAP_NUMBER correspondant  la case de coordonnes setgrid_x et setgrid_y

setGrid	tya
		pha				; sauve y sur la pile

		clc				; pour une addition
		ldy	setgrid_y		; numro de ligne (0  8)
		lda	_grid_y,y		; quivaut  a=y*9
		adc	setgrid_x		; plus numro de la case
		tay

		lda	_state
		sta	HEAP_STATE,y	; tat de la case getgrid_x et getgrid_y

		lda	_number
		sta	HEAP_NUMBER,y	; chiffre de la case getgrid_x et getgrid_y

		pla
		tay				; rcupre y
		rts

;--------------------------------------------------------------------

; void Erase() registres x et y inchangs par cette nouvelle fonction
; Efface tous les chiffres drafts (les hypothses)
; Met  jour l'tat dans le tableau HEAP_STATE, le chiffre dans le tableau
; HEAP_NUMBER et l'affichage  l'cran correspondant  chacun des drafts

erase	txa				; sauve les registres x et y
		pha
		tya
		pha
		ldy #$00			; pour 1re ligne
erase_1	ldx #$00			; pour 1re case de la ligne
erase_2	stx getgrid_x
		sty getgrid_y		; mise  jour des coordonnes pour getGrid
		jsr getGrid		; lit l'tat et le chiffre de la case
		lda _state		; teste l'tat
		cmp #STATE_DRAFT	; est-ce une hypothse ? (#$02)
		bne erase_3		; non, passe  la case suivante
		dec _state		; oui, tat passe  normal (#$01)
		lda #$00
		sta _number		; et vide la case
		stx setgrid_x
		sty setgrid_y		; mise  jour des coordonnes pour getGrid
		jsr setGrid		; met  jour les 2 tableaux tat et chiffre
		stx plot_x
		sty plot_y		; mise  jour des coordonnes pour Plot
		jsr Plot			; met  jour la case dans l'cran
erase_3	inx				; case suivante
		cpx #GRID_MAX + 1	; le bout de la ligne est-il atteint ?
		bne erase_2		; non, reboucle
		iny				; oui, ligne suivante
		cpy #GRID_MAX + 1	; la fin de la grille est-elle atteinte ?
		bne erase_1		; non, reboucle
		pla				; oui, retourne
		tay
		pla				; rcupre les registres y et x
		tax
		rts	

;--------------------------------------------------------------------

; void Convert() registres x et y inchangs par cette nouvelle fonction
; Change tous les tats drafts (les hypothses) en tats normaux
; Met  jour les tats dans le tableau HEAP_STATE et l'affichage  l'cran
; Les chiffres sont inchangs dans HEAP_NUMBER

convert	txa				; sauve les registres x et y
		pha
		tya
		pha
		ldx #$00			; pour indexer les 81 tats
convert_1	lda HEAP_STATE,x	; examine les tats un  un
		cmp #STATE_DRAFT	; Est-ce une hypothse ? (#$02)
		bne convert_2		; non, passe  la case suivante
		dec HEAP_STATE,x	; oui, tat passe  normal (#$01)
convert_2	inx				; cible l'tat de la case suivante
		cpx #LEVEL_SIZE	; la fin du tableau est-elle atteinte ?
		bne convert_1		; non, reboucle
		pla				; oui, retourne
		tay
		pla				; rcupre les registres y et x
		tax
		rts	

;--------------------------------------------------------------------

; void Plot(plot_x,plot_y, _state,_ number) place les attributs de
; couleurs et les chiffres dans la case cible par plot_x et plot_y

Plot		txa				; sauve les registres x et y
		pha
		tya
		pha

		lda	plot_y		; ordonne de la case
		asl	a			; multiplie par 2 (adr sur 2 octets)
		tay				; (c'est pour lire de 2 en 2)
		lda	_screen_y,y		; lit octet de poids faible
		sta	_screen			; et le copie dans _screen
		lda	_screen_y + 1,y	; lit octet de poids fort et le copie
		sta	_screen + 1		; dans _screen + 1 _screen contient
							; l'adresse de la ligne dans l'cran
		ldy	plot_x		; abscisse de la case
		lda	_screen_x,y	; lit l'offset  ajouter  l'adresse de la
		tay				; ligne et le copie dans le registre Y
		ldx	_state		; lit l'tat de la case dans
		lda	_grid_state,x	; puis l'attribut correspondant  cet tat
		sta	(_screen),y	; et le place dans l'cran

		iny				; pour placer chiffre  droite de attribut
		ldx	_number		; lit le chiffre  crire dans registre X
		lda	_state		; reprend l'tat dans l'accumulateur A
		cmp	#STATE_DRAFT	; est-ce 'draft' (hypothse) ?
		bne	plot1		; non, bypasse les 2 lignes de codes suiv.
		lda	_grid_draft,x	; oui, traitement spcial: lit le chiffre
		bne	plot2		; 'compact' et bypasse ligne de code suiv.
plot1	lda	_grid_number,x	; lit le '.' ou chiffre de taille normale
plot2	ldx	plot_x		; abscisse de la case o crire
		cpx	_x			; compare  l'abscisse du curseur
		bne	plot3		; branche si diffrent
		ldx	plot_y		; ordonne de la case o crire
		cpx	_y			; compare  l'ordonne du curseur
		bne	plot3		; branche si diffrent
		ora	#$80			; vido inverse si identiques
plot3	sta	(_screen),y	; crit le chiffre dans l'cran
		
		pla
		tay
		pla				; rcupre les registres y et x
		tax
		rts

;--------------------------------------------------------------------

; void drawLevel(_level) Affiche le numro de grille en haut de l'cran
; NB. Le choix de ce nom de sous-programme est assez contestable

drawLevel	ldx	_level		; numro de grille (de 0  19)
		inx				; numro  afficher (de 1  20)
		txa				; A = numro  afficher (de 1  20)
		ldx	#'0'			; X = Ascii #$30 (chiffre des dizaines = 0)

drawlevel1	cmp	#10		; A-10 fictif  (10 dcimal) 
		bmi	drawlevel2	; sort si A de 1  9 (chiffre des units)
		sec				; ralise A=A-10 
		sbc	#10			; ce qui donne A de 0  10
		inx				; X = caractre Ascii #$31 (dizaine 1, puis 2)
		bne	drawlevel1	; rebouclage obligatoire (X jamais nul)

drawlevel2	clc
		adc	#'0'			; convertit chiffre des units en Ascii
		stx	RAM_LORES + (1 * 40) + 19	; chiffre des dizaines
		sta	RAM_LORES + (1 * 40) + 20	; chiffre des units	

		rts

;--------------------------------------------------------------------

; void drawBlock() Dessine un "carr" (bloc de9x7) jaune sur blanc. 
; Ce sous-programme est appel par startup pour dessiner un bloc 
; de 3x3 chiffres, avec les attributs et espaces cela fait 9x7.
; En entre _screen contint l'adresse du coin haut gauche du bloc.

drawBlock	txa					; sauve les registres X et Y
		pha
		tya
		pha

		ldx	#$00

drawblock1	lda	#GRID_PAPER	; jaune
		ldy	#$00
		sta	(_screen),y		; place attribut jaune  l'adr
		lda	#DEFAUT_PAPER		; blanc
		ldy	#GRID_WIDTH  		; 9
		sta	(_screen),y		; rtablit blanc 9 cases plus loin
		
		clc					; calcule adr suivante ( mme
		lda	_screen			; abscisse mais ligne en dessous)
		adc	#40
		sta	_screen
		bcc	drawblock2		; si pas de retenue
		inc	_screen + 1

drawblock2	inx				; ligne suivante
		cpx	#GRID_HEIGHT		; 7
		bne	drawblock1

		pla					; rcupre les registres Y et X
		tay
		pla
		tax
		rts

;--------------------------------------------------------------------

_filename1	string 'LOAD"SUDSET00"'
		db	0

_filename2	string 'SAVEO"SUDJEU",A#2100,E#2252'
		db	0

_filename3	string 'LOAD"SUDJEU"'
		db	0

_filename4	string 'LOAD"SUDOKU02.SCR"'
		db	0

_filename5	string 'LOAD"SUDOKU03.SCR"'
		db	0

_filename6	string 'ESAVE"SWAP"'
		db	0

_filename7	string 'LOAD"SWAP"'
		db	0

_grid_block	dw	RAM_LORES + (GRID_X - 1)  + (GRID_Y - 1) * 40
		dw	RAM_LORES + (GRID_X + 17) + (GRID_Y - 1) * 40
		dw	RAM_LORES + (GRID_X + 8) + (GRID_Y + 6) * 40
		dw	RAM_LORES + (GRID_X - 1)  + (GRID_Y + 13) * 40
		dw	RAM_LORES + (GRID_X + 17) + (GRID_Y + 13) * 40

_grid_state	db	GRID_COLOR1
		db	GRID_COLOR2
		db	GRID_COLOR3

_grid_number	db	'.'
		db	'1'
		db	'2'
		db	'3'
		db	'4'
		db	'5'
		db	'6'
		db	'7'
		db	'8'
		db	'9'

_grid_draft	db	'.'
		db	'a'
		db	'b'
		db	'c'
		db	'd'
		db	'e'
		db	'f'
		db	'g'
		db	'h'
		db	'i'

_grid_y		db	(0 * 9)				; 0
		db	(1 * 9)				; 1
		db	(2 * 9)				; 2
		db	(3 * 9)				; 3
		db	(4 * 9)				; 4
		db	(5 * 9)				; 5
		db	(6 * 9)				; 6
		db	(7 * 9)				; 7
		db	(8 * 9)				; 8

_grid_xdiv3	db	0
		db	0
		db	0				; 0,1,2	
		db	3
		db	3
		db	3				; 3,4,5
		db	6
		db	6
		db	6				; 6,7,8
		
_screen_x	db	GRID_X + (0 * 2)		; 0
		db	GRID_X + (1 * 2)		; 1
		db	GRID_X + (2 * 2)		; 2
		db	GRID_X + (3 * 2) + 3		; 3
		db	GRID_X + (4 * 2) + 3		; 4
		db	GRID_X + (5 * 2) + 3		; 5
		db	GRID_X + (6 * 2) + 6		; 6
		db	GRID_X + (7 * 2) + 6		; 7
		db	GRID_X + (8 * 2) + 6		; 8
	
_screen_y	dw	RAM_LORES + (GRID_Y +  0) * 40	; 0
		dw	RAM_LORES + (GRID_Y +  2) * 40	; 1
		dw	RAM_LORES + (GRID_Y +  4) * 40	; 2
		dw	RAM_LORES + (GRID_Y +  7) * 40	; 3
		dw	RAM_LORES + (GRID_Y +  9) * 40	; 4
		dw	RAM_LORES + (GRID_Y + 11) * 40	; 5
		dw	RAM_LORES + (GRID_Y + 14) * 40	; 6
		dw	RAM_LORES + (GRID_Y + 16) * 40	; 7
		dw	RAM_LORES + (GRID_Y + 18) * 40	; 8
		dw	RAM_LORES + 27 * 40		; 9 (choice)

_shift_key	db	KEY_SHIFT_1
		db	KEY_SHIFT_2
		db	KEY_SHIFT_3
		db	KEY_SHIFT_4
		db	KEY_SHIFT_5
		db	KEY_SHIFT_6
		db	KEY_SHIFT_7
		db	KEY_SHIFT_8
		db	KEY_SHIFT_9

_charset_draft	db	%0100	; 1
		db	%1100
		db	%0100
		db	%0100
		db	%1110
		db	%0000
		db	%0000
		db	%0000

		db	%0110	; 2
		db	%1001
		db	%0010
		db	%0100
		db	%1111
		db	%0000
		db	%0000
		db	%0000

		db	%1111	; 3
		db	%0001
		db	%0010
		db	%1001
		db	%0110
		db	%0000
		db	%0000
		db	%0000

		db	%0010	; 4
		db	%0110
		db	%1010
		db	%1111
		db	%0010
		db	%0000
		db	%0000
		db	%0000

		db	%1111	; 5
		db	%1000
		db	%1110
		db	%0001
		db	%1110
		db	%0000
		db	%0000
		db	%0000

		db	%0110	; 6
		db	%1000
		db	%1110
		db	%1001
		db	%0110
		db	%0000
		db	%0000
		db	%0000

		db	%1111	; 7
		db	%0001
		db	%0010
		db	%0100
		db	%0100
		db	%0000
		db	%0000
		db	%0000

		db	%0110	; 8
		db	%1001
		db	%0110
		db	%1001
		db	%0110
		db	%0000
		db	%0000
		db	%0000

		db	%0110	; 9
		db	%1001
		db	%0111
		db	%0001
		db	%0110
		db	%0000
		db	%0000
		db	%0000

;--------------------------------------------------------------------

End
